unit ARHotKey;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,Commctrl,Menus;

type

  TARHotKey = class(TComponent)
  private
    { Private declarations }

    VFormKeyDown				: TKeyEvent;
    VOnPress					: TNotifyEvent;
    VShortCut					: TShortCut;


    procedure AROnKeyDown (Sender: TObject; var Key: word; Shift: TShiftState);

  protected
    { Protected declarations }
  public
    { Public declarations }
    constructor Create(AOwner : TComponent);override;
    destructor Destroy; override;
  published
    { Published declarations }
    property OnPressed: TNotifyEvent read VOnPress write VOnPress;
    property HotKey: TShortCut read VShortCut write VShortCut;

  end;

procedure Register;

implementation

constructor TARHotKey.Create(AOwner : TComponent);
begin
	inherited Create(AOwner);
	VFormKeyDown := TForm(AOwner).OnKeyDown;
	TForm(AOwner).OnKeyDown := AROnKeyDown;
	if csDesigning in ComponentState then
		begin
			case TForm(AOwner).KeyPreview of
				False:
					begin
						if MessageDlg('******* Information *********'+#10
									 +'Form is not in KeyPreview Mode.'+#10
									 +'This object needs the Form to be'+#10
									 +'in this state. Should it modify to'+#10
									 +'KeyPreview to True.',mtInformation,[mbYes,mbNo],0) = mrYes then
										begin
											TForm(AOwner).KeyPreview := True;
										end;
					end;
			end;
		end;

end;

destructor TARHotKey.Destroy;
begin
	inherited Destroy;
end;

procedure TARHotKey.AROnKeyDown (Sender: TObject; var Key: word; Shift: TShiftState);
var
	Tecla					: TShortCut;
begin
	if Assigned(VFormKeyDown) then
		VFormKeyDown(Sender,Key,Shift);
		
	if Key = VK_Shift then
		exit;

	if Key = VK_Control then
		exit;

	if Key = VK_Menu then
		exit;

	Tecla := ShortCut(Key, Shift);
	if VShortCut = Tecla then
		begin
			if Assigned(VOnPress) then
				VOnPress(Self);
		end;
end;
procedure Register;
begin
  RegisterComponents('Albert Research', [TARHotKey]);
end;

end.
